(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@s-libs/js-core'), require('@s-libs/micro-dash'), require('rxjs'), require('rxjs/operators'), require('@s-libs/rxjs-core')) :
    typeof define === 'function' && define.amd ? define('@s-libs/app-state', ['exports', '@s-libs/js-core', '@s-libs/micro-dash', 'rxjs', 'rxjs/operators', '@s-libs/rxjs-core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['s-libs'] = global['s-libs'] || {}, global['s-libs']['app-state'] = {}), global.jsCore, global.microDash, global.rxjs, global.rxjs.operators, global.rxjsCore));
}(this, (function (exports, jsCore, microDash, rxjs, operators, rxjsCore) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var Store = /** @class */ (function (_super) {
        __extends(Store, _super);
        function Store(getRootStore) {
            var _this = _super.call(this, function (childKey) {
                var _a, _b;
                return ((_b = (_a = _this.activeChildren[childKey]) === null || _a === void 0 ? void 0 : _a.values().next()) === null || _b === void 0 ? void 0 : _b.value) ||
                    new ChildStore(getRootStore, _this, childKey);
            }) || this;
            _this.getRootStore = getRootStore;
            /**
             * An `Observable` of the state of this store object.
             */
            _this.$ = new rxjs.Observable(function (subscriber) {
                var value = _this.state();
                _this.subscribers.set(subscriber, value);
                _this.maybeActivate();
                subscriber.next(value);
                return function () {
                    _this.subscribers.delete(subscriber);
                    _this.maybeDeactivate();
                };
            });
            _this.subscribers = new Map();
            _this.activeChildren = {};
            _this.lastKnownStateChanged = false;
            return _this;
        }
        /**
         * Assigns the given values to state of this store object. The resulting state will be like `Object.assign(store.state(), value)`.
         */
        Store.prototype.assign = function (value) {
            this.setUsing(function (state) {
                if (microDash.every(value, function (innerValue, key) { return state[key] === innerValue; })) {
                    return state;
                }
                else {
                    return Object.assign(Object.assign({}, state), value);
                }
            });
        };
        /**
         * Runs `func` on the state and replaces it with the return value. The first argument to `func` will be the state, followed by the arguments in `args`.
         *
         * WARNING: You SHOULD NOT use a function that will mutate the state.
         */
        Store.prototype.setUsing = function (func) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.set(func.apply(void 0, __spread([this.state()], args)));
        };
        /**
         * Runs `func` on a shallow clone of the state, replacing the state with the clone. The first argument to `func` will be the cloned state, followed by the arguments in `args`.
         *
         * WARNING: You SHOULD NOT use a function that will mutate nested objects within the state.
         */
        Store.prototype.mutateUsing = function (func) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var state = microDash.clone(this.state());
            func.apply(void 0, __spread([state], args));
            this.set(state);
        };
        Store.prototype.updateState = function (value) {
            if (value === this.lastKnownState) {
                return;
            }
            this.lastKnownState = value;
            this.lastKnownStateChanged = true;
            microDash.forOwn(this.activeChildren, function (children, key) {
                var e_1, _c;
                try {
                    for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                        var child = children_1_1.value;
                        child.updateState(value === null || value === void 0 ? void 0 : value[key]);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (children_1_1 && !children_1_1.done && (_c = children_1.return)) _c.call(children_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            });
        };
        Store.prototype.maybeEmit = function () {
            var _this = this;
            if (!this.lastKnownStateChanged) {
                return;
            }
            this.lastKnownStateChanged = false;
            this.subscribers.forEach(function (lastEmitted, subscriber) {
                if (lastEmitted !== _this.lastKnownState) {
                    subscriber.next(_this.lastKnownState);
                    _this.subscribers.set(subscriber, _this.lastKnownState);
                }
            });
            microDash.forOwn(this.activeChildren, function (children) {
                var e_2, _c;
                try {
                    // `children` can be undefined if emitting from a previous key caused removed all subscribers to this key
                    for (var _d = __values(children || []), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var child = _e.value;
                        child.maybeEmit();
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_c = _d.return)) _c.call(_d);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            });
        };
        Store.prototype.isChildActive = function (parent, key, child) {
            var _a;
            return (_a = parent.activeChildren[key]) === null || _a === void 0 ? void 0 : _a.has(child);
        };
        Store.prototype.activateChild = function (parent, key, child) {
            var set = parent.activeChildren[key];
            if (!set) {
                set = parent.activeChildren[key] = new Set();
            }
            set.add(child);
            parent.maybeActivate();
        };
        Store.prototype.deactivateChild = function (parent, key, child) {
            var set = parent.activeChildren[key];
            set.delete(child);
            if (set.size === 0) {
                delete parent.activeChildren[key];
                parent.maybeDeactivate();
            }
        };
        return Store;
    }(jsCore.CallableObject));

    var RootStore = /** @class */ (function (_super) {
        __extends(RootStore, _super);
        function RootStore(state) {
            var _this = _super.call(this, function () { return _this; }) || this;
            _this.batchCount = 0;
            _this.set(state);
            return _this;
        }
        RootStore.prototype.set = function (value) {
            this.updateState(value);
            this.maybeEmit();
        };
        RootStore.prototype.delete = function () {
            this.set(undefined);
        };
        RootStore.prototype.state = function () {
            return this.lastKnownState;
        };
        /**
         * Turns off this store's observables while `func` is executing, emitting only once afterward, if the store changed. This allows you to batch multiple mutations into a single update at the end.
         *
         * ```ts
         * store.batch(() => {
         *   store.assign({ key1: value1 });
         *   store('key2').delete();
         *   store('key3').set({ key4: value4 });
         *
         *   store('key1').state(); // returns `value1`
         * });
         * ```
         */
        RootStore.prototype.batch = function (func) {
            ++this.batchCount;
            try {
                func();
            }
            finally {
                if (--this.batchCount === 0) {
                    this.maybeEmit();
                }
            }
        };
        RootStore.prototype.refersToSameStateAs = function (other) {
            return this === other;
        };
        RootStore.prototype.maybeEmit = function () {
            if (this.batchCount === 0) {
                _super.prototype.maybeEmit.call(this);
            }
        };
        RootStore.prototype.maybeActivate = function () {
            // root stores are always active
        };
        RootStore.prototype.maybeDeactivate = function () {
            // root stores are always active
        };
        return RootStore;
    }(Store));

    /** @hidden */
    var ChildStore = /** @class */ (function (_super) {
        __extends(ChildStore, _super);
        function ChildStore(getRootStore, parent, key) {
            var _this = _super.call(this, getRootStore) || this;
            _this.parent = parent;
            _this.key = key;
            return _this;
        }
        ChildStore.prototype.set = function (value) {
            if (value === this.state()) {
                return;
            }
            var parentState = microDash.clone(this.parent.state());
            if (!parentState) {
                throw new Error('cannot modify when parent state is missing');
            }
            parentState[this.key] = value;
            this.parent.set(parentState);
        };
        ChildStore.prototype.delete = function () {
            this.parent.setUsing(microDash.omit, this.key);
        };
        ChildStore.prototype.state = function () {
            var _a;
            if (this.isActive()) {
                return this.lastKnownState;
            }
            else {
                return (_a = this.parent.state()) === null || _a === void 0 ? void 0 : _a[this.key];
            }
        };
        ChildStore.prototype.refersToSameStateAs = function (other) {
            return (other instanceof ChildStore &&
                this.key === other.key &&
                this.parent.refersToSameStateAs(other.parent));
        };
        ChildStore.prototype.maybeActivate = function () {
            var _a;
            if (!this.isActive() && this.shouldBeActive()) {
                this.activateChild(this.parent, this.key, this);
                this.lastKnownState = (_a = this.parent.state()) === null || _a === void 0 ? void 0 : _a[this.key];
            }
        };
        ChildStore.prototype.maybeDeactivate = function () {
            if (this.isActive() && !this.shouldBeActive()) {
                this.deactivateChild(this.parent, this.key, this);
            }
        };
        ChildStore.prototype.shouldBeActive = function () {
            return this.subscribers.size > 0 || !microDash.isEmpty(this.activeChildren);
        };
        ChildStore.prototype.isActive = function () {
            return this.isChildActive(this.parent, this.key, this);
        };
        return ChildStore;
    }(Store));

    // this exists to resolve the order of some circular imports

    /**
     * Adds `item` to the end of the array in `store`. Returns a store object representing the newly added item.
     *
     * ```ts
     * declare const store: Store<number[]>; // assume store starts with [1, 2]
     * const added = pushToStoreArray(store, 3); // store has [1, 2, 3]
     * added.set(17); // store has [1, 2, 17]
     * ```
     */
    function pushToStoreArray(store, item) {
        var itemStore = store(store.state().length);
        itemStore.set(item);
        return itemStore;
    }

    /**
     * Returns an observable that emits an array of store objects, one for each element in `source`'s state. The resulting arrays will have references to the exact store objects included in the previous emission when possible, making them performant to use in `*ngFor` expressions without the need to use `trackBy`.
     *
     * ```ts
     * @Component({
     *   template: `
     *     <hero
     *       *ngFor="let heroStore of heroStores$ | async"
     *       [heroStore]="heroStore"
     *     ></hero>
     *   `,
     * })
     * class HeroListComponent {
     *   heroStores$: Observable<Array<Store<Hero>>>;
     *   @Input() private heroesStore: Store<Array<Hero>>;
     *
     *   ngOnChanges() {
     *     this.heroStores$ = spreadArrayStore(this.heroesStore);
     *   }
     * }
     * ```
     */
    function spreadArrayStore$(source) {
        var cache = [];
        return source.$.pipe(operators.distinctUntilKeyChanged('length'), operators.map(function (array) {
            if (array.length < cache.length) {
                cache = cache.slice(0, array.length);
            }
            else {
                cache = cache.slice();
                for (var i = cache.length; i < array.length; ++i) {
                    cache[i] = source(i);
                }
            }
            return cache;
        }));
    }

    /**
     * Returns an observable that emits an array of store objects, one for each element in `source`'s state. The resulting arrays will have references to the exact store objects included in the previous emission when possible, making them performant to use in `*ngFor` expressions without the need to use `trackBy`.
     *
     * ```ts
     * interface HeroMap {
     *   [name: string]: Hero;
     * }
     *
     * @Component({
     *   template: `
     *     <hero
     *       *ngFor="let heroStore of heroStores$ | async"
     *       [heroStore]="heroStore"
     *     ></hero>
     *   `,
     * })
     * class HeroListComponent {
     *   heroStores$: Observable<Array<Store<Hero>>>;
     *   @Input() private heroesStore: Store<HeroMap>;
     *
     *   ngOnChanges() {
     *     this.heroStores$ = spreadObjectStore(this.heroesStore);
     *   }
     * }
     * ```
     */
    function spreadObjectStore$(source) {
        var lastKeySet;
        return source.$.pipe(operators.filter(function (value) {
            var keySet = new Set(microDash.keys(value));
            if (lastKeySet && jsCore.isSetEqual(keySet, lastKeySet)) {
                return false;
            }
            lastKeySet = keySet;
            return true;
        }), rxjsCore.mapAndCacheObjectElements(function (_value, key) { return key; }, function (_value, key) { return source(key); }));
    }

    var UndoManager = /** @class */ (function () {
        /**
         * @param maxDepth The maximum size of the history before discarding the oldest state. `0` means no limit.
         */
        function UndoManager(store, maxDepth) {
            if (maxDepth === void 0) { maxDepth = 0; }
            this.store = store;
            this.maxDepth = maxDepth;
            this.stack = [];
            this.canUndoSubject = new rxjs.ReplaySubject(1);
            this.canRedoSubject = new rxjs.ReplaySubject(1);
            this.stateSubject = new rxjs.ReplaySubject(1);
            this.collectDebouncer = new jsCore.Debouncer();
            /**
             * An observable that emits the result of `canUndo()` every time that value changes.
             */
            this.canUndo$ = this.canUndoSubject.pipe(operators.distinctUntilChanged());
            /**
             * An observable that emits the result of `canRedo()` every time that value changes.
             */
            this.canRedo$ = this.canRedoSubject.pipe(operators.distinctUntilChanged());
            /**
             * An observable that emits the current state every time it changes.
             */
            this.state$ = this.stateSubject.pipe(operators.distinctUntilChanged());
            this.reset();
        }
        /**
         * Discard all history and push the current state.
         */
        UndoManager.prototype.reset = function () {
            this.currentStateIndex = -1;
            this.pushCurrentState();
        };
        /**
         * Add the current state to the undo history. Any states that could be reached using `redo()` are discarded.
         *
         * @param collectKey When specified, multiple pushes in a row with the same key will be collected into a single undo state. This is useful e.g. for collecting changes from a text input into larger undo states, rather than undoing one character at a time. After a push with a different key or another undo change (like `.undo()` or `.reset()`), collecting will stop and the next push will be in a new undo state.
         * @param collectDebounce If at least this many milliseconds elapse with no other push, the next one will be to a new undo state regardless of its `collectKey`. Defaults to `undefined`, which sets no such timeout.
         */
        UndoManager.prototype.pushCurrentState = function (_a) {
            var _b = _a === void 0 ? {} : _a, _c = _b.collectKey, collectKey = _c === void 0 ? undefined : _c, _d = _b.collectDebounce, collectDebounce = _d === void 0 ? undefined : _d;
            var nextState = this.extractUndoState(this.store.state());
            if (this.currentStateIndex >= 0 && !this.shouldPush(nextState)) {
                return;
            }
            if (this.prepush(nextState, collectKey)) {
                this.actuallyPush(nextState, collectKey, collectDebounce);
            }
        };
        /**
         * @returns whether any states are available for `undo()`
         */
        UndoManager.prototype.canUndo = function () {
            return this.currentStateIndex > 0;
        };
        /**
         * @returns whether any states are available for `redo()`
         */
        UndoManager.prototype.canRedo = function () {
            return this.currentStateIndex < this.stack.length - 1;
        };
        /**
         * Move backward one step in the history of states saved via `pushCurrentState()`, setting the store to contain that state again.
         *
         * @throws Error when there is no such state (i.e. when `canUndo()` returns false)
         */
        UndoManager.prototype.undo = function () {
            if (!this.canUndo()) {
                throw new Error('Cannot undo');
            }
            this.changeState(-1, 'undo');
        };
        /**
         * Move forward one step in the history of states saved via `pushCurrentState()`, setting the store to contain that state again.
         *
         * @throws Error when there is no such state (i.e. when `canRedo()` returns false)
         */
        UndoManager.prototype.redo = function () {
            if (!this.canRedo()) {
                throw new Error('Cannot redo');
            }
            this.changeState(1, 'redo');
        };
        /**
         * Drops the state from the internal undo stack that would be applied by a call to `.undo()`. This is useful e.g. if making multiple changes in a row that should be collapsed into a single undo state: call this first before pushing the new version.
         *
         * @throws Error when there is no such state (i.e. when `canUndo()` returns false)
         */
        UndoManager.prototype.dropCurrentUndoState = function () {
            if (!this.canUndo()) {
                throw new Error('Nothing to drop');
            }
            this.currentStateIndex = this.currentStateIndex - 1;
            this.dropRedoHistory();
            this.emitUndoChanges();
        };
        Object.defineProperty(UndoManager.prototype, "currentUndoState", {
            /**
             * Returns the current undo state that was most recently pushed or applied. Calls to `undo` will apply the state before this in teh stack, and `redo` will apply the state after this.
             */
            get: function () {
                return this.stack[this.currentStateIndex];
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(UndoManager.prototype, "undoStack", {
            /**
             * Returns a view of the internal undo stack, from oldest to newest. Note that this contains states that would be applied by calls to both `.undo()` and `.redo`.
             */
            get: function () {
                return this.stack.slice();
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Used to determine whether `.pushCurrentState()` actually does anything. Override this e.g. to prevent pushing a duplicate undo state using something like this:
         *
         * ```ts
         * protected shouldPush(state: UndoStateType) {
         *   return equal(state, this.currentUndoState);
         * }
         * ```
         */
        UndoManager.prototype.shouldPush = function (_state) {
            return true;
        };
        UndoManager.prototype.dropRedoHistory = function () {
            this.stack.splice(this.currentStateIndex + 1, this.stack.length);
        };
        /**
         * Each time a state is added to the history, this method will be called to determine whether the oldest state should be dropped. Override to implement more complex logic than the simple `maxDepth`.
         */
        UndoManager.prototype.isOverSize = function (size) {
            return this.maxDepth > 0 && size > this.maxDepth;
        };
        UndoManager.prototype.changeState = function (change, undoOrRedo) {
            var _this = this;
            var stateToOverwrite = this.currentUndoState;
            this.currentStateIndex += change;
            var stateToApply = this.currentUndoState;
            this.store.getRootStore().batch(function () {
                _this.applyUndoState(stateToApply, undoOrRedo, stateToOverwrite);
            });
            this.emitUndoChanges();
        };
        UndoManager.prototype.emitUndoChanges = function (collectKey, collectDebounce) {
            var _this = this;
            this.canUndoSubject.next(this.canUndo());
            this.canRedoSubject.next(this.canRedo());
            this.stateSubject.next(this.stack[this.currentStateIndex]);
            this.currentCollectKey = collectKey;
            if (collectDebounce !== undefined) {
                this.collectDebouncer.run(function () {
                    _this.currentCollectKey = undefined;
                }, collectDebounce);
            }
        };
        UndoManager.prototype.prepush = function (nextState, collectKey) {
            if (collectKey && this.currentCollectKey === collectKey) {
                --this.currentStateIndex;
                this.dropRedoHistory();
                if (!this.shouldPush(nextState)) {
                    return false;
                }
            }
            return true;
        };
        UndoManager.prototype.actuallyPush = function (nextState, collectKey, collectDebounce) {
            ++this.currentStateIndex;
            this.stack[this.currentStateIndex] = nextState;
            this.dropRedoHistory();
            while (this.stack.length > 1 && this.isOverSize(this.stack.length)) {
                this.stack.shift();
                --this.currentStateIndex;
            }
            this.emitUndoChanges(collectKey, collectDebounce);
        };
        return UndoManager;
    }());

    /*
     * Public API Surface of app-state
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.RootStore = RootStore;
    exports.Store = Store;
    exports.UndoManager = UndoManager;
    exports.pushToStoreArray = pushToStoreArray;
    exports.spreadArrayStore$ = spreadArrayStore$;
    exports.spreadObjectStore$ = spreadObjectStore$;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=s-libs-app-state.umd.js.map
